import pytest

from mlair.data_handler.data_handler_with_filter import DataHandlerFilter, DataHandlerFilterSingleStation, \
    DataHandlerFirFilter, DataHandlerFirFilterSingleStation, DataHandlerClimateFirFilter, \
    DataHandlerClimateFirFilterSingleStation
from mlair.data_handler.data_handler_single_station import DataHandlerSingleStation
from mlair.data_handler.default_data_handler import DefaultDataHandler
from mlair.helpers.testing import get_all_args


class TestDataHandlerFilter:

    def test_requirements(self):
        reqs = get_all_args(DataHandlerFilter, DefaultDataHandler)
        obj = object.__new__(DataHandlerFilter)
        assert sorted(obj.own_args()) == reqs
        reqs = get_all_args(DataHandlerSingleStation, DataHandlerFilterSingleStation, remove=["self"])
        assert sorted(obj._requirements) == reqs
        reqs = get_all_args(DataHandlerSingleStation, DataHandlerFilterSingleStation, DefaultDataHandler,
                            DataHandlerFilter, remove=["self", "id_class"])
        assert sorted(obj.requirements()) == reqs


class TestDataHandlerFilterSingleStation:

    def test_requirements(self):
        reqs = get_all_args(DataHandlerFilterSingleStation, DataHandlerSingleStation)
        obj = object.__new__(DataHandlerFilterSingleStation)
        assert sorted(obj.own_args()) == reqs
        assert sorted(obj._requirements) == []
        reqs = get_all_args(DataHandlerFilterSingleStation, DataHandlerSingleStation, remove="self")
        assert sorted(obj.requirements()) == reqs


class TestDataHandlerFirFilter:

    def test_requirements(self):
        reqs = get_all_args(DataHandlerFilter, DefaultDataHandler)
        obj = object.__new__(DataHandlerFirFilter)
        assert sorted(obj.own_args()) == reqs
        reqs = get_all_args(DataHandlerSingleStation, DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation,
                            remove=["self"])
        assert sorted(obj._requirements) == reqs
        reqs = get_all_args(DataHandlerSingleStation, DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation,
                            DataHandlerFilter, DefaultDataHandler, remove=["self", "id_class"])
        assert sorted(obj.requirements()) == reqs


class TestDataHandlerFirFilterSingleStation:

    def test_requirements(self):

        reqs = get_all_args(DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation, DataHandlerSingleStation)
        obj = object.__new__(DataHandlerFirFilterSingleStation)
        assert sorted(obj.own_args()) == reqs
        assert sorted(obj._requirements) == []
        reqs = get_all_args(DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation, DataHandlerSingleStation,
                            remove="self")
        assert sorted(obj.requirements()) == reqs


class TestDataHandlerClimateFirFilter:

    def test_requirements(self):
        reqs = get_all_args(DataHandlerFilter, DefaultDataHandler)
        obj = object.__new__(DataHandlerClimateFirFilter)
        assert sorted(obj.own_args()) == reqs
        reqs = get_all_args(DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation, DataHandlerSingleStation,
                            DataHandlerClimateFirFilterSingleStation, remove="self")
        assert sorted(obj._requirements) == reqs
        reqs = get_all_args(DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation, DataHandlerSingleStation,
                            DataHandlerClimateFirFilterSingleStation, DefaultDataHandler, DataHandlerFilter,
                            remove=["self", "id_class"])
        assert sorted(obj.requirements()) == reqs


class TestDataHandlerClimateFirFilterSingleStation:

    def test_requirements(self):
        reqs = get_all_args(DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation, DataHandlerSingleStation,
                            DataHandlerClimateFirFilterSingleStation)
        obj = object.__new__(DataHandlerClimateFirFilterSingleStation)
        assert sorted(obj.own_args()) == reqs
        assert sorted(obj._requirements) == []
        reqs = get_all_args(DataHandlerFirFilterSingleStation, DataHandlerFilterSingleStation, DataHandlerSingleStation,
                            DataHandlerClimateFirFilterSingleStation, remove="self")
        assert sorted(obj.requirements()) == reqs
